<template>
  <div class="w-auto h-auto bg-background-50">
    <div class="text-center p-5">
      <AppLabel> Add new list</AppLabel>
      <AppButton
        size="default"
        color="gray"
        label="Add"
        @click="modalAdd = true"
      ></AppButton>
      <AppModal
        size="sm"
        v-if="modalAdd"
        @click="addList"
        @close="modalAdd = false"
      >
        <template v-slot:header>
          <div class="">
            <AppLabel>Task</AppLabel>
            <AppInput
              type="text"
              id="title"
              name="title"
              v-model="title"
            ></AppInput>
          </div>
        </template>
      </AppModal>
    </div>

    <div class="grid grid-cols-1 sm:grid-cols-2">
      <div class="w-full sm:w-1/2 sm:m-10 md:m-10 md:w-2/3 lg:m-10 lg:w-1/2">
        <div class="text-center">
          <AppLabel size="xl">To Do</AppLabel>
        </div>
        <draggable class="list-group" :list="list1" group="people">
          <div
            class="list-group-item"
            v-for="(element, index) in list1"
            :key="element.title"
          >
            <AppCard class="w-full m-5 text-sm shadow-xl">
              <div class="flex justify-between">
                <div class="pt-1">
                  <p v-if="!isEditing">{{ element.title }}</p>
                  <AppInput
                    v-else
                    type="text"
                    v-model="element.title"
                  ></AppInput>
                </div>
                <div>
                  <AppButton
                    v-if="!isEditing"
                    label="Edit"
                    class="inline-block mr-4"
                    color="gray"
                    @click="isEditing = true"
                  ></AppButton>
                  <AppButton
                    v-else
                    label="Update"
                    class="inline-block mr-4"
                    color="gray"
                    @click="editList"
                  ></AppButton>
                  <AppButton
                    class="inline-block"
                    label="delete"
                    color="red"
                    @click="modalDelete = true"
                  ></AppButton>
                </div>
              </div>
            </AppCard>
            <AppModal
              v-if="modalDelete"
              @close="modalDelete = false"
              @click="deleteList(index)"
            >
              <template v-slot:header> Delete this item? </template>
            </AppModal>
          </div>
        </draggable>
      </div>
      <div class="w-full sm:w-1/2 sm:m-10 md:m-10 md:w-2/3 lg:w-1/2 lg:m-10">
        <div class="text-center">
          <AppLabel size="xl">Progress</AppLabel>
        </div>
        <draggable class="list-group" :list="list2" group="people">
          <div
            class="list-group-item"
            v-for="(element, index) in list2"
            :key="element.title"
          >
            <AppCard class="w-full m-5 text-sm shadow-xl">
              <div class="flex justify-between">
                <div class="pt-1">
                  <p v-if="!isProgressEditing">{{ element.title }}</p>
                  <AppInput
                    v-else
                    type="text"
                    v-model="element.title"
                  ></AppInput>
                </div>
                <div>
                  <AppButton
                    v-if="!isProgressEditing"
                    label="Edit"
                    class="inline-block mr-4"
                    color="gray"
                    @click="isProgressEditing = true"
                  ></AppButton>
                  <AppButton
                    v-else
                    label="Update"
                    class="inline-block mr-4"
                    color="gray"
                    @click="editProgressList"
                  ></AppButton>
                  <AppButton
                    class="inline-block"
                    label="delete"
                    color="red"
                    @click="modalProgressDelete = true"
                  ></AppButton>
                </div>
              </div>
              <AppModal
                v-if="modalProgressDelete"
                @close="modalProgressDelete = false"
                @click="deleteProgressList(index)"
              >
                <template v-slot:header> Delete this item? </template>
              </AppModal>
            </AppCard>
          </div>
        </draggable>
      </div>
    </div>
  </div>
</template>

<script>
import AppCard from "@/components/base-components/AppCard.vue";
import AppLabel from "@/components/base-components/AppLabel.vue";
import AppButton from "@/components/base-components/AppButton.vue";
import AppModal from "@/components/base-components/AppModal.vue";
import AppInput from "@/components/base-components/AppInput.vue";
import draggable from "vuedraggable";

export default {
  data() {
    return {
      modalDelete: false,
      modalProgressDelete: false,
      modalAdd: false,
      modalEdit: false,
      isEditing: false,
      isProgressEditing: false,
      id: 7,
      title: "",
      list1: [
        {
          id: 1,
          title: "test",
        },
        {
          id: 2,
          title: "do it asap",
        },
        {
          id: 7,
          title: "lm",
        },
      ],
      list2: [
        {
          id: 3,
          title: "test",
        },
        {
          id: 4,
          title: "another task",
        },
        {
          id: 5,
          title: "new todo",
        },
        {
          id: 6,
          title: "test",
        },
      ],
    };
  },
  components: { AppLabel, AppButton, AppModal, AppInput, draggable, AppCard },

  methods: {
    deleteList(index) {
      if (this.list1 && this.list1.length > 0) {
        this.list1.splice(index, 1);
      }
      this.modalDelete = false;
    },
    deleteProgressList(index) {
      if (this.list2 && this.list2.length > 0) {
        this.list2.splice(index, 1);
      }
      this.modalProgressDelete = false;
    },
    addList() {
      this.id++;
      this.list1.push({
        title: this.title,
        id: this.id,
      });
      this.modalAdd = false;
    },
    editList() {
      this.isEditing = false;
    },
    editProgressList() {
      this.isProgressEditing = false;
    },
  },
};
</script>

<style></style>
